Index: main/trunk/model-interfaces-dev/heritage-nz/transform/pages/classifier.xsl
===================================================================
--- main/trunk/model-interfaces-dev/heritage-nz/transform/pages/classifier.xsl	(revision 33199)
+++ main/trunk/model-interfaces-dev/heritage-nz/transform/pages/classifier.xsl	(revision 33200)
@@ -42,7 +42,7 @@
       <div id="rightSidebar">
 	<xsl:comment>Filler needed for div</xsl:comment>
+	<xsl:call-template name="viewOptions"/>
 	<xsl:if test="$berryBasketOn or ($documentBasketOn and (util:contains(/page/pageRequest/userInformation/@groups, 'administrator') or util:contains(/page/pageRequest/userInformation/@groups, 'all-collections-editor') or util:contains(/page/pageRequest/userInformation/@groups, $thisCollectionEditor)))">
 	  <xsl:if test="$berryBasketOn">
-	    <xsl:call-template name="viewOptions"/>
 	    <!-- show the berry basket if it's turned on -->
 	    <div class="tableOfContentsContainer" style="position:relative; z-index: 2;"> <!-- **** -->
@@ -53,6 +53,6 @@
 	  
 	  <xsl:if test="$documentBasketOn">
-	  <gslib:documentBasket/>
-	  <xsl:text> </xsl:text>
+	    <gslib:documentBasket/>
+	    <xsl:text> </xsl:text>
 	  </xsl:if>
 	</xsl:if>
@@ -129,4 +129,5 @@
 
           <!-- Floating TOC on/off button -->
+	  <xsl:if test="$berryBasketOn">
 	    <li id="floatingTOCOptions">
 <!--
@@ -135,5 +136,5 @@
 	      <xsl:attribute name="title">Fix the berry basket to the right side of the screen</xsl:attribute>
 	      <img id="floatTOCToggleImage">
-		<xsl:attribute name="src"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'float_toc_image')"/></xsl:attribute>
+		<xsl:attribute name="src"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'float_berrybasket_image')"/></xsl:attribute>
 	      </img>
 
@@ -166,4 +167,5 @@
 	      </script>
 	    </xsl:if>
+	  </xsl:if>
       </ul>
       <div style="clear:both;"><xsl:text> </xsl:text></div>
Index: main/trunk/model-interfaces-dev/heritage-nz/transform/pages/query.xsl
===================================================================
--- main/trunk/model-interfaces-dev/heritage-nz/transform/pages/query.xsl	(revision 33199)
+++ main/trunk/model-interfaces-dev/heritage-nz/transform/pages/query.xsl	(revision 33200)
@@ -11,6 +11,161 @@
 
   <!-- set page title -->
-  <xsl:template name="pageTitle">
+  <xsl:template name="pageTitle">                                                                                                 
     <gslib:collectionNameLinked/><gslib:rightArrow/><gslib:serviceName/>
   </xsl:template>
+
+
+  
+  <xsl:template name="displayBaskets">
+<!--
+    <div id="float-anchor" style="width: 31%; min-width:180px; float:right; margin: 0 0 10px 20px;">
+-->
+<!-- **** -->
+    <div id="float-anchor" style="position: absolute; width: 29%; min-width:180px; top: 105px; right:20px; margin: 0 0 10px 20px;">
+      <xsl:comment>Filler needed for div</xsl:comment>
+      <xsl:call-template name="viewOptions"/>
+
+      <xsl:if test="$berryBasketOn or ($documentBasketOn and (util:contains(/page/pageRequest/userInformation/@groups, 'administrator') or util:contains(/page/pageRequest/userInformation/@groups, 'all-collections-editor') or util:contains(/page/pageRequest/userInformation/@groups, $thisCollectionEditor)))">
+	<div id="rightSidebar" style="margin: 0 0 5px 5px; width: 100%">
+<!--
+The following had been added to default interface version of query.xsl at this point
+Not clear if having the following lines in the 'default' version is desirable or not
+for general look of interface, outside of Heritage-NZ interface.  
+Probably not, as surely it would need some of the other changes to let the view
+options make sense.
+
+	      <xsl:comment>Filler needed for div</xsl:comment>
+	      <xsl:call-template name="viewOptions"/>
+-->
+	  <xsl:if test="$berryBasketOn">
+	    <!-- show the berry basket if it's turned on -->
+	    <div class="tableOfContentsContainer" style="position:relative; z-index: 2;"> <!-- **** -->
+	      <gslib:berryBasket/>
+	      <xsl:text> </xsl:text>
+	    </div>
+	  </xsl:if>
+	  <xsl:if test="$documentBasketOn and (util:contains(/page/pageRequest/userInformation/@groups, 'administrator') or util:contains(/page/pageRequest/userInformation/@groups, 'all-collections-editor') or util:contains(/page/pageRequest/userInformation/@groups, $thisCollectionEditor))">
+	    <gslib:documentBasket/>
+	    <xsl:text> </xsl:text>
+	  </xsl:if>
+	</div>
+      </xsl:if>
+    </div>
+  </xsl:template>
+
+
+
+  <xsl:template name="viewOptions">
+
+    <div id="viewAndZoomOptions" class="ui-state-default ui-corner-all">
+      <ul id="viewOptions">
+	
+
+          <!-- Floating TOC on/off button -->
+	  <xsl:if test="$berryBasketOn">
+	    <li id="floatingTOCOptions">
+<!--
+	      <xsl:attribute name="title"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'doc.floatingTooltip')"/></xsl:attribute>
+-->
+	      <xsl:attribute name="title">Fix the berry basket to the right side of the screen</xsl:attribute>
+	      <img id="floatTOCToggleImage">
+		<xsl:attribute name="src"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'float_berrybasket_image')"/></xsl:attribute>
+	      </img>
+
+	      <input id="floatTOCToggle" type="checkbox"/>
+	      <script type="text/javascript">
+		<xsl:text disable-output-escaping="yes">
+		  $("#floatTOCToggle").prop("checked", false);
+		  $("#floatTOCToggle").click(function()
+		  {
+		    floatMenu($("#floatTOCToggle").prop("checked"));
+		  });
+		  
+		  $("#floatTOCToggleImage").click(function()
+		  {
+		    $("#floatTOCToggle").prop("checked", !$("#floatTOCToggle").prop("checked"))
+		    floatMenu($("#floatTOCToggle").prop("checked"));
+		  });
+		</xsl:text>
+	      </script>
+	    </li>
+	    <xsl:if test="/page/pageRequest/paramList/param[@name='ftoc']/@value = '1'">
+	      <script type="text/javascript">
+		<xsl:text disable-output-escaping="yes">
+		  $(window).load(function()
+		  {
+		    $("#floatTOCToggle").prop("checked", true);
+		    floatMenu(true);
+		  });
+		</xsl:text>
+	      </script>
+	    </xsl:if>
+	  </xsl:if>
+      </ul>
+      <div style="clear:both;"><xsl:text> </xsl:text></div>
+    </div>
+  </xsl:template>
+  
+
+
+	<xsl:template name="displayFacets">
+			<script type="text/javascript" src="interfaces/{$interface_name}/js/utility_scripts.js"><xsl:text> </xsl:text></script>
+			<script type="text/javascript" src="interfaces/{$interface_name}/js/facet-scripts.js">
+				<xsl:text> </xsl:text>
+			</script>
+<!--
+			<div id="facetSelector" style="position: absolute; right: 20px; top: 300px;">
+-->
+<!-- **** -->
+			<div id="facetSelector" style="position: relative; float: right; top: 100px;">
+				<xsl:for-each select="/page/pageResponse/facetList/facet">
+					<xsl:if test="count(count) > 0">
+						<ul class="facetTable ui-widget-content" indexName="{@name}">
+							<xsl:variable name="serviceName">
+								<xsl:value-of select="/page/pageRequest/paramList/param[@name = 's']/@value"/>
+							</xsl:variable>
+							<xsl:variable name="indexShortName">
+								<xsl:value-of select="@name"/>
+							</xsl:variable>
+							<xsl:variable name="countSize">
+								<xsl:choose>
+									<xsl:when test="/page/pageResponse/format[@type='search']/gsf:option[@name='facetTableRows']">
+										<xsl:value-of select="/page/pageResponse/format[@type='search']/gsf:option[@name='facetTableRows']/@value"/>
+									</xsl:when>
+									<xsl:otherwise>8</xsl:otherwise>
+								</xsl:choose>
+							</xsl:variable>
+
+							<li class="ui-widget-header" style="text-transform:capitalize; text-align:center;">
+							  <xsl:value-of select="displayItem[@name='name']"/>
+							</li>
+							<xsl:for-each select="count">
+								<li>
+									<xsl:attribute name="style">
+										<xsl:if test="position() > $countSize">display:none;<xsl:value-of select="$indexShortName"/>
+										</xsl:if>
+									</xsl:attribute>
+									<input type="checkbox" onclick="performRefinedSearch();"/>
+									<span>
+										<xsl:value-of select="@name"/>
+									</span>(<xsl:value-of select="."/>)
+								</li>
+							</xsl:for-each>
+							<xsl:if test="count(count) > $countSize">
+								<li class="expandFacetList{$indexShortName}">
+									<a class="expandFacetListLink{$indexShortName}" href="javascript:expandFacetList('{$indexShortName}', {$countSize});"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'query.facet.more')"/></a>
+								</li>
+								<li class="collapseFacetList{$indexShortName}" style="display: none;">
+									<a  class="collapseFacetListLink{$indexShortName}" href="javascript:collapseFacetList('{$indexShortName}', {$countSize});"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'query.facet.less')"/></a>
+								</li>
+							</xsl:if>
+						</ul>
+					</xsl:if>
+				</xsl:for-each>
+			</div>
+
+	</xsl:template>
+
+
+
 </xsl:stylesheet>