Index: other-projects/is-sheet-music-encore/trunk/Makefile
===================================================================
--- other-projects/is-sheet-music-encore/trunk/Makefile	(revision 33170)
+++ other-projects/is-sheet-music-encore/trunk/Makefile	(revision 33221)
@@ -145,2 +145,20 @@
 	cd image-identification-terminal; less log-houghlinesP-refined-MU.txt
 
+run-classifier-houghlinesP-refined-test-remote:
+        #Compile
+	cd image-identification-terminal; javac javaAccuracyCalculator.java
+	cd image-identification-terminal; javac -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar javaImageClassifier.java;
+        #Run javaImageClassifier on all images in TestImages
+	@echo starting classfier
+	@date
+	cd image-identification-terminal; ./runClassifer.sh /Scratch/cpb16/is-sheet-music-encore/download-images/TestImages houghlinesP-refined log-TestImages.txt -all
+	@echo finished classifier
+	@date
+        #Calculate the Accuracy of the classifier
+	cd image-identification-terminal; java javaAccuracyCalculator log-TestImages.txt houghlinesP-refined-test results.txt
+        #Display output of javaImageClassifier
+	cd image-identification-terminal; less log-TestImages.txt
+        #Display output of javaAccuracyCalculator output
+	cd image-identification-terminal; less results.txt
+	cd image-identification-terminal; rm log-TestImages.txt
+
Index: other-projects/is-sheet-music-encore/trunk/image-identification-development/Makefile
===================================================================
--- other-projects/is-sheet-music-encore/trunk/image-identification-development/Makefile	(revision 33170)
+++ other-projects/is-sheet-music-encore/trunk/image-identification-development/Makefile	(revision 33221)
@@ -2,5 +2,6 @@
 
 run-Classifier01:
-	java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/ terminalImageId
+	javac terminalImageClassifer.java
+	java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/ terminalImageClassifier
 
 
Index: other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaImageClassifier.java
===================================================================
--- other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaImageClassifier.java	(revision 33170)
+++ other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaImageClassifier.java	(revision 33221)
@@ -28,6 +28,6 @@
 public class javaImageClassifier{
 	//Constants
-	static int CLASSIFIER_HOUGHLINESP_MIN = 10;
-	static int CLASSIFIER_HOUGHLINESP_MAX = 50;
+	static int CLASSIFIER_HOUGHLINESP_MIN = 5;
+	static int CLASSIFIER_HOUGHLINESP_MAX = 40;
 
     public static void main(String[] args) {  	
@@ -125,5 +125,6 @@
 	    Mat linesP = new Mat(); // will hold the results of the detection
 	    double minLineLength = edgesDetectedRGB.size().width/4;
-	    Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 180, 50, minLineLength, 10);// runs the actual detection
+	    //Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 180, 50, minLineLength, 10);// runs the actual detection
+            Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 180, 10, minLineLength, 5);// remote testing
 	    // Draw the lines
 	    
@@ -148,4 +149,5 @@
 	    //Calculate if its sheet music or not
 	    isSheetMusic = classifier_HoughLinesP(toBeClassifiedImg);  
+
    		    
 	}
Index: other-projects/is-sheet-music-encore/trunk/image-identification-terminal/results.txt
===================================================================
--- other-projects/is-sheet-music-encore/trunk/image-identification-terminal/results.txt	(revision 33170)
+++ other-projects/is-sheet-music-encore/trunk/image-identification-terminal/results.txt	(revision 33221)
@@ -19,2 +19,25 @@
 OverallAccuracyRate: 67.64648%
 
+
+
+
+Date: Sun Jun 23 17:48:16 NZST 2019
+Classifier: houghlinesP-refined-test
+truePositive: 5
+falseNegative: 5
+falsePositve: 0
+trueNegative: 10
+SheetMusicAccuracyRate: 50.0%
+NotSheetMusicAccuracyRate: 100.0%
+OverallAccuracyRate: 75.0%
+
+Date: Sun Jun 23 17:50:39 NZST 2019
+Classifier: houghlinesP-refined-test
+truePositive: 5
+falseNegative: 5
+falsePositve: 0
+trueNegative: 10
+SheetMusicAccuracyRate: 50.0%
+NotSheetMusicAccuracyRate: 100.0%
+OverallAccuracyRate: 75.0%
+
Index: other-projects/is-sheet-music-encore/trunk/image-identification-terminal/runClassifer.sh
===================================================================
--- other-projects/is-sheet-music-encore/trunk/image-identification-terminal/runClassifer.sh	(revision 33170)
+++ other-projects/is-sheet-music-encore/trunk/image-identification-terminal/runClassifer.sh	(revision 33221)
@@ -38,3 +38,18 @@
 		done
 		;;
+	-small)
+		#Runs javaImageClassifier on 100 images
+		for file_name in $folder_name/*/*.png; do
+		if [ $i -lt 50 ] ; then
+			echo $file_name
+			echo $output_filename
+			echo $i
+			echo ""
+			java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaImageClassifier $file_name $classifier_type $output_filename
+			i=$[$i+1]
+		else
+			exit 0
+		fi		
+		done
+		;;
 esac		